// Copyright 1998-2017 Epic Games, Inc. All Rights Reserved.

#include "BiscuitGameMode.h"
#include "BiscuitPlayerController.h"
#include "BiscuitCharacter.h"
#include "UObject/ConstructorHelpers.h"

ABiscuitGameMode::ABiscuitGameMode()
{
	// use our custom PlayerController class
	PlayerControllerClass = ABiscuitPlayerController::StaticClass();

	// set default pawn class to our Blueprinted character
	static ConstructorHelpers::FClassFinder<APawn> PlayerPawnBPClass(TEXT("/Game/TopDownCPP/Blueprints/TopDownCharacter"));
	if (PlayerPawnBPClass.Class != NULL)
	{
		DefaultPawnClass = PlayerPawnBPClass.Class;
	}
}