// Fill out your copyright notice in the Description page of Project Settings.

#include "SfsChatWidget.h"
#include "BiscuitCharacter.h"
#include "Biscuit.h"

void USfsChatWidget::OnExecuteUserLogin(FString username)
{
	// Convert blueprint username from FString to std string
	boost::shared_ptr<string> stdUsername(new string(TCHAR_TO_UTF8(*username)));

	// Validate username
	if (stdUsername->length() == 0)
	{
		return;
	}

	// Validate reference to SmartFox Server handler
	if (m_ptrCharacter == NULL)
	{
		return;
	}

	ABiscuitCharacter* m_ptrCharacter2 = (ABiscuitCharacter*)m_ptrCharacter;

	if (m_ptrCharacter2->IsSmartFoxServerConnected() == true)
	{
		return;
	}

	// Initialize SmartFox connection
	m_ptrCharacter2->SmartFoxInitialize();

	// Validate connection status of SmartFox Server
	if (m_ptrCharacter2->IsSmartFoxServerConnected() == false)
	{
		return;
	}

	// Perform login on SmartFox Server
	m_ptrCharacter2->SmartFoxLogin(*stdUsername);
}

void USfsChatWidget::OnExecuteChatMessage(FString message)
{
	// Convert blueprint message from FString to std string
	boost::shared_ptr<string> stdMessage(new string(TCHAR_TO_UTF8(*message)));

	// Validate message
	if (stdMessage->length() == 0)
	{
		return;
	}

	// Validate reference to SmartFox Server handler
	if (m_ptrCharacter == NULL)
	{
		return;
	}

	ABiscuitCharacter* m_ptrCharacter2 = (ABiscuitCharacter*)m_ptrCharacter;

	// Validate connection status of SmartFox Server
	if (m_ptrCharacter2->IsSmartFoxServerConnected() == false)
	{
		return;
	}

	// Perform message transmission to SmartFox Server
	m_ptrCharacter2->SmartFoxSendChatMessage(*stdMessage);
}

void USfsChatWidget::ShowChatMessage(string username, string message)
{
	// Propagate received chat message as blueprint event
	string messageToShow = username + " say: " + message;
	ChatMessageEvent(FString(messageToShow.c_str()));
}

void USfsChatWidget::SetBiscuitCharacter(ACharacter* ptrCharacter)
{
	m_ptrCharacter = ptrCharacter;
}

void USfsChatWidget::SetLoginMode()
{
	LoginModeEvent();
}

void USfsChatWidget::SetChatMode()
{
	ChatModeEvent();
}
SfsChatWidget_eventChatMessageEvent_Parms ChatMessageEventProcessor(const FString &message)
{
	SfsChatWidget_eventChatMessageEvent_Parms Parms;
	Parms.message = message;
	return Parms;
}
