// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

// -------------------------------------------------------------------------
// API includes
// -------------------------------------------------------------------------
#include "F:/FlyingCookie/Biscuit/SmartFoxClientAPI/SmartFox.h"
#include "F:/FlyingCookie/Biscuit/SmartFoxClientAPI/Core/BaseEvent.h"
#include "F:/FlyingCookie/Biscuit/SmartFoxClientAPI/Bitswarm/BitSwarmEvent.h"
#include "F:/FlyingCookie/Biscuit/SmartFoxClientAPI/Util/EventDispatcher.h"
#include "F:/FlyingCookie/Biscuit/SmartFoxClientAPI/Requests/ExtensionRequest.h"
#include "F:/FlyingCookie/Biscuit/SmartFoxClientAPI/Requests/LoginRequest.h"
#include "F:/FlyingCookie/Biscuit/SmartFoxClientAPI/Util/SFSErrorCodes.h"
#include "F:/FlyingCookie/Biscuit/SmartFoxClientAPI/Core/BoostAsio/Windows/boost/shared_ptr.hpp"
#include <iostream>

// -------------------------------------------------------------------------

#include "CoreMinimal.h"
#include "Blueprint/UserWidget.h"
#include "SfsChatWidget.generated.h"

/**
 * 
 */
UCLASS()
class BISCUIT_API USfsChatWidget : public UUserWidget
{
	GENERATED_BODY()
	
public:

	UFUNCTION(BlueprintCallable, Category = CppCallback)
		void OnExecuteUserLogin(FString username);

	UFUNCTION(BlueprintCallable, Category = CppCallback)
		void OnExecuteChatMessage(FString message);

	UFUNCTION(BlueprintImplementableEvent, Category = ViewMode)
		void LoginModeEvent();

	UFUNCTION(BlueprintImplementableEvent, Category = ViewMode)
		void ChatModeEvent();

	UFUNCTION(BlueprintImplementableEvent, Category = ViewMode)
		void ChatMessageEvent(SfsChatWidget_eventChatMessageEvent_Parms parms);

	/*
	* Set reference to game character
	* This is a shortcut for demo to get access SmartFox Server in SfsLoginWidget: please use best approach in a real product (interface or share smartfox instance or other)
	* @param ptrCharacter	reference to character instance
	*/
	void SetBiscuitCharacter(ACharacter* ptrCharacter);

	SfsChatWidget_eventChatMessageEvent_Parms ChatMessageEventProcessor(const FString &message)


	/**
	* Set widget UI in login mode
	*/
	void SetLoginMode();

	/**
	* Set widget UI in chat mode
	*/
	void SetChatMode();

	/**
	* Show chat message
	* @param ptrUser		name of the user that has sent the message
	* @param ptrMessage		chat message
	*/
	void ShowChatMessage(string username, string message);

private:

	// Reference to character instance
	ACharacter* m_ptrCharacter = NULL;
	
	
};
